#include <bits/stdc++.h>

using namespace std;
#define int long long
#define F first
#define S second
int k, _, maxn;
struct rect {
    int x1, y1, x2, y2;
};
struct qr {
    int x, y1, y2, tp;
};

bool cmp(qr x1, qr x2) {
    if (x1.x == x2.x) {
        return x1.tp > x2.tp;
    }
    return x1.x < x2.x;
}

struct Node {
    int mn, sum, add;
};

Node unite(Node v1, Node v2) {
    if (v1.mn == v2.mn)return {v1.mn, v1.sum + v2.sum, 0};
    else if (v1.mn < v2.mn) return {v1.mn, v1.sum, 0};
    else return {v2.mn, v2.sum, 0};
}

vector<Node> tr;

void push(int v) {
    if (v >= maxn || tr[v].add == 0)return;
    tr[v * 2].add += tr[v].add;
    tr[v * 2].mn += tr[v].add;
    tr[v * 2 + 1].add += tr[v].add;
    tr[v * 2 + 1].mn += tr[v].add;
    tr[v].add = 0;
}

void upd(int v, int lv, int rv, int l, int r, int x) {
    push(v);
    if (lv >= r || rv <= l)return;
    if (lv >= l && rv <= r) {
        tr[v].add += x;
        tr[v].mn += x;
        return;
    }
    int mid = (lv + rv) / 2;
    upd(v * 2, lv, mid, l, r, x);
    upd(v * 2 + 1, mid, rv, l, r, x);
    tr[v] = unite(tr[v * 2], tr[v * 2 + 1]);
}

Node getans(int v, int lv, int rv, int l, int r) {
    if (lv >= r || rv <= l)return {INT32_MAX, 0, 0};
    if (lv >= l && rv <= r)return tr[v];
    int mid = (lv + rv) / 2;
    return unite(getans(v * 2, lv, mid, l, r), getans(v * 2 + 1, mid, rv, l, r));
}

int maxpow2(int x) {
    int y = 1;
    while (y < x)y *= 2;
    return y;
}

vector<rect> a;
vector<qr> b;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> k >> _;
    pair<int, int> now = {0, 0};
    while (_--) {
        char t;
        cin >> t;
        int y;
        cin >> y;
        pair<int, int> next;
        if (t == 'N') {
            next = {now.F, now.S + y};
            a.push_back({now.F, now.S, next.F + k, next.S + k});
        }
        if (t == 'S') {
            next = {now.F, now.S - y};
            a.push_back({next.F, next.S, now.F + k, now.S + k});
        }
        if (t == 'E') {
            next = {now.F + y, now.S};
            a.push_back({now.F, now.S, next.F + k, next.S + k});
        }
        if (t == 'W') {
            next = {now.F - y, now.S};
            a.push_back({next.F, next.S, now.F + k, now.S + k});
        }
        now = next;
    }
    set<int> ys;
    for (auto &i: a) {
        ys.insert(i.y1);
        ys.insert(i.y2);
        b.push_back({i.x1, i.y1, i.y2, 1});
        b.push_back({i.x2, i.y1, i.y2, -1});
    }
    map<int, int> mp;
    vector<int> mama;
    int nw = 0;
    for (int i: ys) {
        mp[i] = nw;
        nw++;
        mama.push_back(i);
    }
    sort(b.begin(), b.end(), cmp);
    vector<int> cnt(ys.size() - 1, 0);
    maxn = maxpow2((int) ys.size() - 1);
    tr.resize(2 * maxn, {0, 0, 0});
    for (int i = 0; i < ys.size() - 1; ++i) {
        tr[i + maxn].sum = mama[i + 1] - mama[i];
    }
    for (int i = maxn - 1; i >= 1; --i) {
        tr[i] = unite(tr[i * 2], tr[i * 2 + 1]);
    }
    int ans = 0;
    for (int i = 0; i < b.size(); ++i) {
        if (i) {
            Node u = getans(1, 0, maxn, 0, cnt.size());
            if (u.mn != 0) {
                ans += (b[i].x - b[i - 1].x) * (mama[mama.size() - 1] - mama[0]);
            } else {
                ans += (b[i].x - b[i - 1].x) * (mama[mama.size() - 1] - mama[0] - u.sum);
            }
//            for (int j = 0; j < cnt.size(); ++j) {
//                if (cnt[j]) {
//                    ans += (b[i].x - b[i - 1].x) * (mama[j + 1] - mama[j]);
//                }
//            }
        }
        if (b[i].tp == 1) {
            int l = mp[b[i].y1];
            int r = mp[b[i].y2];
            upd(1, 0, maxn, l, r, 1);
            //  for (int j = l; j < r; ++j)cnt[j]++;
        } else {
            int l = mp[b[i].y1];
            int r = mp[b[i].y2];
            upd(1, 0, maxn, l, r, -1);
            //for (int j = l; j < r; ++j)cnt[j]--;
        }
    }
    cout << ans;
    return 0;
}/*
 * 1 5
E 2
N 2
W 4
S 4
E 4
 */